@echo off

SET RESULT=---

if "%PROCESSOR_ARCHITECTURE%" == "AMD64" goto x64
goto x86

:x86
echo Installing hardware driver for 32-bit OS...
echo.

FOR /D %%d IN ("%windir%\WinSxS\x86_microsoft.vc90.crt_????????????????_9.0.30729*") DO (
    SET RESULT=%%d
)

IF NOT EXIST "%RESULT%" (
    ECHO Installing requirement: Visual Studio C++ 2008 SP1 Redistributable x86
    cd vcredist
    vcredist_x86.exe /q
    ECHO Finished installation of Visual Studio C++ 2008 SP1 Redistributable x86
    cd..
)

cd bin_x86
dpinst /SW /F /SE
goto installDone

:x64
echo Installing hardware driver for 64-bit OS...
echo.

FOR /D %%d IN ("%windir%\WinSxS\amd64_microsoft.vc90.crt_????????????????_9.0.30729*") DO (
    SET RESULT=%%d
)

IF NOT EXIST "%RESULT%" (
    ECHO Installing requirement: Visual Studio C++ 2008 SP1 Redistributable x64
    cd vcredist
    vcredist_x64.exe /q
    ECHO Finished installation of Visual Studio C++ 2008 SP1 Redistributable x64
    cd..
)
cd bin_x64
dpinst /SW /F /SE
goto installDone


:installDone
if %errorlevel% == -2147418112 goto installationFailed
if %errorlevel% == 256 goto successNoDeviceFound
if %errorlevel% == 1073741826 goto successRestartRequired
if %errorlevel% == 1 goto successEnd
if %errorlevel% == -2147483648 goto userCancelled
goto successEnd

:userCancelled
echo The installation was cancelled by user.
cd..
REM Set exit code to 3 (cancelled)
exit /b 3

:installationFailed
echo Installation has failed.
cd..
REM Set exit code to 2 (installation failed)
exit /b 2

:successNoDeviceFound
echo Installation has succeeded. You can use the driver when you connect the device.
cd..
REM Set exit code to 0
exit /b 0

:successRestartRequired
echo Installation has succeeded. You need to restart your computer to work with the device
cd..
REM Set exit code to 1 (installation succeed, but requires restart)
exit /b 1

:successEnd
cd..
echo Device was found and installation of driver has succeeded
